/[gentoo-x86]/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r1.ebuild
Gentoo

Contents of /net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r1.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.2 - (show annotations) (download)
Wed Jan 12 19:51:44 2011 UTC (9 years, 5 months ago) by alexxy
Branch: MAIN
CVS Tags: HEAD
Changes since 1.1: +1 -1 lines
FILE REMOVED
[net-wireless/wpa_supplicant] Fix bug #351174. Thanks to Fabio Correa

(Portage version: 2.2.0_alpha14_p1/cvs/Linux x86_64)

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/net-wireless/wpa_supplicant/wpa_supplicant-0.7.3-r1.ebuild,v 1.1 2010/11/08 17:39:02 alexxy Exp $
4
5 EAPI="2"
6
7 inherit eutils toolchain-funcs qt4-r2
8
9 DESCRIPTION="IEEE 802.1X/WPA supplicant for secure wireless transfers"
10 HOMEPAGE="http://hostap.epitest.fi/wpa_supplicant/"
11 SRC_URI="http://hostap.epitest.fi/releases/${P}.tar.gz"
12 LICENSE="|| ( GPL-2 BSD )"
13
14 SLOT="0"
15 KEYWORDS="~amd64 ~arm ~ppc ~ppc64 ~x86 ~x86-fbsd"
16 IUSE="dbus debug gnutls eap-sim fasteap madwifi ps3 qt4 readline ssl wimax wps kernel_linux kernel_FreeBSD"
17
18 RDEPEND="dbus? ( sys-apps/dbus )
19 kernel_linux? (
20 eap-sim? ( sys-apps/pcsc-lite )
21 madwifi? ( ||
22 ( >net-wireless/madwifi-ng-tools-0.9.3
23 net-wireless/madwifi-old )
24 )
25 dev-libs/libnl
26 )
27 !kernel_linux? ( net-libs/libpcap )
28 qt4? ( x11-libs/qt-gui:4
29 x11-libs/qt-svg:4 )
30 readline? ( sys-libs/ncurses sys-libs/readline )
31 wimax? ( !net-wireless/libeap )
32 ssl? ( dev-libs/openssl )
33 !ssl? ( gnutls? ( net-libs/gnutls ) )
34 !ssl? ( !gnutls? ( dev-libs/libtommath ) )"
35 DEPEND="${RDEPEND}
36 dev-util/pkgconfig"
37
38 S="${WORKDIR}/${P}/${PN}"
39
40 pkg_setup() {
41 if use fasteap && (use gnutls || use ssl) ; then
42 die "If you use fasteap, you must build with wpa_supplicant's internal TLS implementation. That is, both 'gnutls' and 'ssl' USE flags must be disabled"
43 fi
44
45 if use gnutls && use ssl ; then
46 einfo "You have both 'gnutls' and 'ssl' USE flags enabled: defaulting to USE=\"ssl\""
47 fi
48 }
49
50 src_prepare() {
51 # net/bpf.h needed for net-libs/libpcap on Gentoo/FreeBSD
52 sed -i \
53 -e "s:\(#include <pcap\.h>\):#include <net/bpf.h>\n\1:" \
54 ../src/l2_packet/l2_packet_freebsd.c || die
55
56 # People seem to take the example configuration file too literally (bug #102361)
57 sed -i \
58 -e "s:^\(opensc_engine_path\):#\1:" \
59 -e "s:^\(pkcs11_engine_path\):#\1:" \
60 -e "s:^\(pkcs11_module_path\):#\1:" \
61 wpa_supplicant.conf || die
62
63 # Change configuration to match Gentoo locations (bug #143750)
64 sed -i \
65 -e "s:/usr/lib/opensc:/usr/$(get_libdir):" \
66 -e "s:/usr/lib/pkcs11:/usr/$(get_libdir):" \
67 wpa_supplicant.conf || die
68
69 epatch "${FILESDIR}/${P}-dbus_path_fix.patch"
70
71 if use wimax; then
72 cd "${WORKDIR}/${P}"
73 epatch "${FILESDIR}/${P}-generate-libeap-peer.patch"
74 fi
75
76 # bug (320097)
77 epatch "${FILESDIR}/do-not-call-dbus-functions-with-NULL-path.patch"
78 }
79
80 src_configure() {
81 # Toolchain setup
82 echo "CC = $(tc-getCC)" > .config
83
84 # Basic setup
85 echo "CONFIG_CTRL_IFACE=y" >> .config
86 echo "CONFIG_BACKEND=file" >> .config
87
88 # Basic authentication methods
89 # NOTE: we don't set GPSK or SAKE as they conflict
90 # with the below options
91 echo "CONFIG_EAP_GTC=y" >> .config
92 echo "CONFIG_EAP_MD5=y" >> .config
93 echo "CONFIG_EAP_OTP=y" >> .config
94 echo "CONFIG_EAP_PAX=y" >> .config
95 echo "CONFIG_EAP_PSK=y" >> .config
96 echo "CONFIG_EAP_TLV=y" >> .config
97 echo "CONFIG_IEEE8021X_EAPOL=y" >> .config
98 echo "CONFIG_PKCS12=y" >> .config
99 echo "CONFIG_PEERKEY=y" >> .config
100 echo "CONFIG_EAP_LEAP=y" >> .config
101 echo "CONFIG_EAP_MSCHAPV2=y" >> .config
102 echo "CONFIG_EAP_PEAP=y" >> .config
103 echo "CONFIG_EAP_TLS=y" >> .config
104 echo "CONFIG_EAP_TTLS=y" >> .config
105
106 if use dbus ; then
107 echo "CONFIG_CTRL_IFACE_DBUS=y" >> .config
108 fi
109
110 if use debug ; then
111 echo "CONFIG_DEBUG_FILE=y" >> .config
112 fi
113
114 if use eap-sim ; then
115 # Smart card authentication
116 echo "CONFIG_EAP_SIM=y" >> .config
117 echo "CONFIG_EAP_AKA=y" >> .config
118 echo "CONFIG_EAP_AKA_PRIME=y" >> .config
119 echo "CONFIG_PCSC=y" >> .config
120 fi
121
122 if use fasteap ; then
123 echo "CONFIG_EAP_FAST=y" >> .config
124 fi
125
126 if use readline ; then
127 # readline/history support for wpa_cli
128 echo "CONFIG_READLINE=y" >> .config
129 fi
130
131 # SSL authentication methods
132 if use ssl ; then
133 echo "CONFIG_TLS=openssl" >> .config
134 echo "CONFIG_SMARTCARD=y" >> .config
135 elif use gnutls ; then
136 echo "CONFIG_TLS=gnutls" >> .config
137 echo "CONFIG_GNUTLS_EXTRA=y" >> .config
138 else
139 echo "CONFIG_TLS=internal" >> .config
140 fi
141
142 if use kernel_linux ; then
143 # Linux specific drivers
144 echo "CONFIG_DRIVER_ATMEL=y" >> .config
145 #echo "CONFIG_DRIVER_BROADCOM=y" >> .config
146 #echo "CONFIG_DRIVER_HERMES=y" >> .config
147 echo "CONFIG_DRIVER_HOSTAP=y" >> .config
148 echo "CONFIG_DRIVER_IPW=y" >> .config
149 echo "CONFIG_DRIVER_NDISWRAPPER=y" >> .config
150 echo "CONFIG_DRIVER_NL80211=y" >> .config
151 #echo "CONFIG_DRIVER_PRISM54=y" >> .config
152 echo "CONFIG_DRIVER_RALINK=y" >> .config
153 echo "CONFIG_DRIVER_WEXT=y" >> .config
154 echo "CONFIG_DRIVER_WIRED=y" >> .config
155
156 if use madwifi ; then
157 # Add include path for madwifi-driver headers
158 echo "CFLAGS += -I/usr/include/madwifi" >> .config
159 echo "CONFIG_DRIVER_MADWIFI=y" >> .config
160 fi
161
162 if use ps3 ; then
163 echo "CONFIG_DRIVER_PS3=y" >> .config
164 fi
165
166 elif use kernel_FreeBSD ; then
167 # FreeBSD specific driver
168 echo "CONFIG_DRIVER_BSD=y" >> .config
169 fi
170
171 # Wi-Fi Protected Setup (WPS)
172 if use wps ; then
173 echo "CONFIG_WPS=y" >> .config
174 fi
175
176 # Enable mitigation against certain attacks against TKIP
177 echo "CONFIG_DELAYED_MIC_ERROR_REPORT=y" >> .config
178
179 if use qt4 ; then
180 cd "${S}"/wpa_gui-qt4
181 eqmake4 wpa_gui.pro
182 fi
183 }
184
185 src_compile() {
186 einfo "Building wpa_supplicant"
187 emake || die "emake failed"
188
189 if use wimax; then
190 emake -C ../src/eap_peer clean || die "emake failed"
191 emake -C ../src/eap_peer || die "emake failed"
192 fi
193
194 if use qt4 ; then
195 cd "${S}"/wpa_gui-qt4
196 einfo "Building wpa_gui"
197 emake || die "wpa_gui compilation failed"
198 fi
199 }
200
201 src_install() {
202 dosbin wpa_supplicant || die
203 dobin wpa_cli wpa_passphrase || die
204
205 # baselayout-1 compat
206 if has_version "<sys-apps/baselayout-2.0.0"; then
207 dodir /sbin
208 dosym /usr/sbin/wpa_supplicant /sbin/wpa_supplicant || die
209 dodir /bin
210 dosym /usr/bin/wpa_cli /bin/wpa_cli || die
211 fi
212
213 if has_version ">=sys-apps/openrc-0.5.0"; then
214 newinitd "${FILESDIR}/${PN}-init.d" wpa_supplicant
215 newconfd "${FILESDIR}/${PN}-conf.d" wpa_supplicant
216 fi
217
218 exeinto /etc/wpa_supplicant/
219 newexe "${FILESDIR}/wpa_cli.sh" wpa_cli.sh
220
221 dodoc ChangeLog {eap_testing,todo}.txt README{,-WPS} \
222 wpa_supplicant.conf || die "dodoc failed"
223
224 doman doc/docbook/*.{5,8} || die "doman failed"
225
226 if use qt4 ; then
227 into /usr
228 dobin wpa_gui-qt4/wpa_gui || die
229 doicon wpa_gui-qt4/icons/wpa_gui.svg || die "Icon not found"
230 make_desktop_entry wpa_gui "WPA Supplicant Administration GUI" "wpa_gui" "Qt;Network;"
231 fi
232
233 if use wimax; then
234 emake DESTDIR="${D}" -C ../src/eap_peer install || die
235 fi
236
237 if use dbus ; then
238 cd "${S}"/dbus
239 insinto /etc/dbus-1/system.d
240 newins dbus-wpa_supplicant.conf wpa_supplicant.conf || die
241 insinto /usr/share/dbus-1/system-services
242 doins fi.epitest.hostap.WPASupplicant.service || die
243 keepdir /var/run/wpa_supplicant
244 fi
245 }
246
247 pkg_postinst() {
248 einfo "If this is a clean installation of wpa_supplicant, you"
249 einfo "have to create a configuration file named"
250 einfo "/etc/wpa_supplicant/wpa_supplicant.conf"
251 einfo
252 einfo "An example configuration file is available for reference in"
253 einfo "/usr/share/doc/${PF}/"
254
255 if [[ -e ${ROOT}etc/wpa_supplicant.conf ]] ; then
256 echo
257 ewarn "WARNING: your old configuration file ${ROOT}etc/wpa_supplicant.conf"
258 ewarn "needs to be moved to ${ROOT}etc/wpa_supplicant/wpa_supplicant.conf"
259 fi
260
261 if use madwifi ; then
262 echo
263 einfo "This package compiles against the headers installed by"
264 einfo "madwifi-old, madwifi-ng or madwifi-ng-tools."
265 einfo "You should re-emerge ${PN} after upgrading these packages."
266 fi
267 }

  ViewVC Help
Powered by ViewVC 1.1.20